/* 
  f-cpu/c/fcpusim/mem_view.c
  shows status of the memory
  Copyright (C) 2002 Jaap Stolk (JWS) jwstolk@yahoo.com
  version:
Wed Jul 24 13:03:21 CEST 2002 JWS: created.
Mon Jul 29 10:17:09 CEST 2002 JWS: added display_color and display_normal

 ------------------------BEGIN-LICENSE------------------------------------
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 ---------------------------END-LICENSE-----------------------------------
*/

#include <stdio.h>
#include <fcpusim.h>

void mem_view(void){

  int mem_view_cnt;
  int ascii_cnt;

  printf("memory dump");
  for (mem_view_cnt=0; mem_view_cnt<16; mem_view_cnt++){
    printf("%2X ",mem_view_cnt);
    if ((mem_view_cnt % 4)==3){
      printf(" ");
    }
  }
  for (mem_view_cnt=0; mem_view_cnt<16; mem_view_cnt++){
    printf("%1X",mem_view_cnt);
  }

  for (mem_view_cnt=0; mem_view_cnt<(16*20); mem_view_cnt++){
    if ((mem_view_cnt % 16)==0){
      printf("\n0x%8X:" ,mem_view_cnt);
    }
    printf("%s%2X%s ", display_color, sim_memory[mem_view_cnt], display_normal );
    if ((mem_view_cnt % 4)==3){
      printf(" ");
    }
    if ((mem_view_cnt % 16)==15){
      for (ascii_cnt=mem_view_cnt-16;ascii_cnt<mem_view_cnt;ascii_cnt++){
        if ((sim_memory[ascii_cnt]<' ')||(sim_memory[ascii_cnt]>'~')){
          printf("%s.%s", display_color, display_normal );
        }else{
          printf("%s%c%s", display_color, sim_memory[ascii_cnt], display_normal );
        }
      }
    }
  }
  printf("\n");

}
