/*
  f-cpu/c/scheduler/fetcher.h
  fetcher unit ports for F-CPU simulator
  Copyright (C) 2002 Jaap Stolk (JWS) jwstolk@yahoo.com
  version:
           19 July 2002 13:30
Mon Jul 22 23:02:02 CEST 2002 JWS: finisched major scheduling update
Fri Aug  2 17:25:00 CEST 2002 JWS: added JMP support

 ------------------------BEGIN-LICENSE------------------------------------
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 ---------------------------END-LICENSE-----------------------------------

*/

#ifndef FETCHER_H
#define FETCHER_H

#include <f-cpu_config.h>

/* inputs: */
u64  fet_pc_in;
bool fet_use_new_pc;

/* outputs: */
u64 fet_cpc;    /* currernt IP */
u64 fet_npc;    /* next IP */
u32 fet_instr;
u8  fet_operand_1;
u8  fet_operand_2;
u8  fet_operand_dst;


/* internal: */
u64  fet_pc;

/* problem : they should be enums !! */

static inline void fetcher_cycle (void);

#endif /* FETCHER_H */
