/*
  f-cpu/c/toplevel/toplevel.h - F-CPU simulator
  Copyright (C) 2002 Jaap Stolk (JWS) jwstolk@yahoo.com
  version:
           19 July 2002 13:30
    Jul 21 02:30:00 CEST 2002 JWS
Sun Jul 28 11:24:35 CEST 2002 JWS: added MAX_EU_LATENCY

 ------------------------BEGIN-LICENSE------------------------------------
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 ---------------------------END-LICENSE-----------------------------------
*/

#ifndef TOPLEVEL_H
#define TOPLEVEL_H

#define SIM_MEMORY_SIZE 10240    /* 10k of code / data memory  */
#define MAX_EU_LATENCY  6+2      /* (MUL=6) excluding DIV  */

                                /* +1 s we can shift after adding the new values */
                                 /* +1 s we can check for free slots before we clear the start level */

#include <f-cpu_config.h>

bool bist_active;                /* when this becomes false we fetch the first instr. */
bool stalled = 0;                /* set by the scheduler unit */

u8 sim_memory[SIM_MEMORY_SIZE];  /* simulated code / data memory */


#endif /* TOPLEVEL_H */
