//     Winograd 8-bin DCT for a "baseline" JPG compressor
//            (C) 2002 whygee@f-cpu.org
// converted for f-cpu simulator by jwstolk@yahoo.com
//    version:   Mon Jul 29 18:41:33 CEST 2002
//
// input:  20,21,22,23,24,25,26,27   (was: a0..a7)
// output: 30,31,32,33,34,35,36,37   (was: s0..s7)
// const:     41,42,43,44            (was: m1..m4)
// temporary registers: R1, R2, R3, R4, R5, R6, R7, R8, R9, R10;

// const. and input are set by the simulator.
// no simd, etc. all done in 64 bit.

  add r27, r20, r7  ; // process input
  add r26, r21, r6  ;
  sub r24, r22, r4  ;
  sub r26, r21, r5  ;
  add r25, r22, r9  ;
  add r24, r23, r10 ;
  sub r25, r22, r3  ;
  sub r27, r20, r8  ;

  add r10, r7,  r1  ;
  sub r9,  r6,  r2  ;
  add r3,  r4,  r4  ;
  add r3,  r5,  r3  ;
  sub r10, r7,  r7  ;
  add r8,  r5,  r5  ;
  add r9,  r6,  r9  ;

  mul r3,  r41, r3  ;
  add r7,  r2,  r2  ;
  sub r5,  r4,  r6  ;

  mul r4,  r43, r4  ;
  mul r5,  r44, r5  ;
  mul r2,  r41, r2  ;
  mul r6,  r42, r6  ;

  add r9,  r1,  r30 ;
  sub r9,  r1,  r34 ;

  add r8,  r3,  r1  ;
  sub r3,  r8,  r3  ;
  nop;
      /* one free slot here : the multiply is not ready */
      /* and it creates one stall in the simulator :-)  */
      /* you can start using S0(r30) and S4(r34) now    */
  add r2,  r7,  r32 ;
  add r6,  r4,  r4  ;
  sub r2,  r7,  r36 ;
  add r6,  r5,  r2  ;

  sub r4,  r3,  r33 ;
  add r4,  r3,  r35 ;
  add r2,  r1,  r31 ;
  sub r2,  r1,  r37 ;

#EOF
